#include <stddef.h>
#include "table.hpp"
#include "arbre.hpp"
#include "an_lex.hpp"
#include "an_syn.hpp"

int suivant() {
  lexemes = lexemes -> succ;
  return(lexemes != NULL);
};

int test_g(genre x) {
  return((lexemes -> elt).g == x);
};

int lit_op(char signe) {
  if (test_g(op))
    return((lexemes -> elt).operateur == signe);
  else
    return(0);
};

int lit_pm() {
  return(lit_op('+') || lit_op('-'));
};

int lit_md() {
  return(lit_op('*') || lit_op('/'));
};

int lit_po() {
  return(lit_op('('));
};

int lit_pf() {
  if (lit_op(')'))
    return(1);
  else
    if (erreur == 0) erreur = 3;
  return(0);
};

int lit_ident() {
  if (test_g(ident))
    return(1);
  else
    if (erreur == 0) erreur = 5;
  return(0);
};

int lit_eg() {
  if (lit_op('='))
    return(1);
  else
    if (erreur == 0) erreur = 6;
  return(0);
};

int lit_cste();
int lit_fact();
int lit_terme();
int lit_expr();
int lit_instr();
int lit_ligne();

int an_syn() {
  return(lit_ligne());
};

int lit_ligne() {
  if (test_g(finl))
    return(1);
  else
    if (lit_instr() && test_g(finl))
      return(1);
    else {
      if (erreur == 0) erreur = 4;
      return(0);
    };
};

int lit_instr() {
  arbre temp;
  boite b;

  if (lit_ident()) {
    temp = cree_noeud(lexemes -> elt);
    if (suivant()) {
      b = lexemes -> elt;
      if (lit_eg() && suivant() && lit_expr()) {
         synt_tree = enracine(temp, b, synt_tree);
         return(1);
      };
    };
  };
  return(0);
};

int lit_expr() {
  arbre temp;
  boite b;

  if (lit_terme())
    if (lit_pm()) {
      temp = synt_tree; b = lexemes -> elt;
      if (suivant() && lit_expr()) {
        synt_tree = enracine(temp, b, synt_tree);
        return(1);
      };
      return(0);
    }
    else
      return(1);
  else
    return(0);
};

int lit_terme() {
  arbre temp;
  boite b;

  if (lit_fact())
    if (lit_md()) {
      temp = synt_tree; b = lexemes -> elt;
      if (suivant() && lit_terme()) {
        synt_tree = enracine(temp, b, synt_tree);
        return(1);
      };
      return(0);
    }
    else
      return(1);
  else
    return(0);
};

int lit_fact() {
  if (lit_po())
    return(suivant() && lit_expr() && lit_pf() && suivant());
  else {
    erreur = 0;
    if (lit_ident()) {
      synt_tree = cree_noeud(lexemes -> elt);
      return(suivant());
    }
    else {
      erreur = 0;
      return(lit_cste() && suivant());
    };
  };
};

int lit_cste() {
  if (lit_pm()) {
    if (suivant() && test_g(cste)) {
      synt_tree = cree_noeud(lexemes -> elt);
      return(1);
    };
  }
  else
    if (test_g(cste)){
      synt_tree = cree_noeud(lexemes -> elt);
      return(1);
    };
  erreur = 2;
  return(0);
};
